//! Wrapper around David Tolnay's dtoa.

use dtoa;
use crate::util::*;

// F32

perftools_inline!{
/// Wrapper for dtoa.
///
/// `f` must be non-special (NaN or infinite), non-negative,
/// and non-zero.
pub(crate) fn float_decimal<'a>(f: f32, bytes: &'a mut [u8])
    -> usize
{
    let mut buffer = dtoa::Buffer::new();
    let string = buffer.format(f);
    bytes[0..string.len()].copy_from_slice(string.as_bytes());
    string.len()
}}

// F64

perftools_inline!{
/// Wrapper for dtoa.
///
/// `d` must be non-special (NaN or infinite), non-negative,
/// and non-zero.
pub(crate) fn double_decimal<'a>(d: f64, bytes: &'a mut [u8])
    -> usize
{
    let mut buffer = dtoa::Buffer::new();
    let string = buffer.format(d);
    bytes[0..string.len()].copy_from_slice(string.as_bytes());
    string.len()
}}
